unit unWordplay;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TfrmWordplay }

  TfrmWordplay = class(TForm)
    btnReverse: TButton;
    btnWordcount: TButton;
    btnVowelCount: TButton;
    Button4: TButton;
    edInput: TEdit;
    labReverse: TLabel;
    labWordcount: TLabel;
    labVowelcount: TLabel;
    Label4: TLabel;
    procedure btnReverseClick(Sender: TObject);
    procedure btnVowelCountClick(Sender: TObject);
    procedure btnWordcountClick(Sender: TObject);
  private

  public

  end;

var
  frmWordplay: TfrmWordplay;

implementation

{$R *.lfm}

{ TfrmWordplay }

procedure TfrmWordplay.btnReverseClick(Sender: TObject);
var temp,rev : string;
    x        : byte;
begin
  //go get a copy of the input
  temp := edinput.Text;
  rev := '';

  //reverse it   doing it backwards
  for x := length(temp) downto 1 do
    rev := rev + temp[x];

  //display reverse
  labReverse.caption := rev

end;

procedure TfrmWordplay.btnVowelCountClick(Sender: TObject);
var j, tally : byte;
    cpy : string;
begin
  //initialise
  cpy := edInput.text;
  tally := 0;

  {//capitalise the copy
  for j := 1 to length(cpy) do
    cpy[j] := upcase(cpy[j]);
  }
  //tally vowels - sucky version
  {for j := 1 to length(cpy) do
    if ((cpy[j]='A') or
        (cpy[j]='E') or
        (cpy[j]='I') or
        (cpy[j]='O') or
        (cpy[j]='U'))
       then inc(tally);}

  //case version ... better
  {for j := 1 to length(cpy) do
    case cpy[j] of
    'A','E','I','O','U' : inc(tally)
    end;}

  //coolest version
  for j := 1 to length(cpy) do
    if cpy[j] in ['a','e','i','o','u',
                  'A','E','I','O','U']
       then inc(tally);


  //output the tally
  labVowelcount.caption := 'there are '+inttostr(tally) + ' vowels';

end;

procedure TfrmWordplay.btnWordcountClick(Sender: TObject);
var cpy      : string;
    tally, i : byte;
begin
  if length(edinput.text) > 0
    then begin
              //initialise tally
              tally := 0;

              //get a copy of the text
              cpy := edinput.Text;

              //look for spaces, incing when I find one
              for i := 1 to length(cpy) do
                if cpy[i] = ' '
                   then inc(tally);

              //output tally + 1
              labWordcount.caption := 'there are '+inttostr(tally+1) + ' words';
        end

end;

end.

